package Pins is

   type Pin_ID is (
      PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7, PA8, PA9, PA10, PA11, PA12,
      PB0, PB1, PB3, PB4, PB5, PB6, PB7,
      PF0, PF1 );
   
   -- Nucleo-32 aliases
   function D0  return Pin_ID renames PA10;
   function D1  return Pin_ID renames PA9;
   function D2  return Pin_ID renames PA12;
   function D3  return Pin_ID renames PB0;
   function D4  return Pin_ID renames PB7;
   function D5  return Pin_ID renames PB6;
   function D6  return Pin_ID renames PB1;
   function D7  return Pin_ID renames PF0;
   function D8  return Pin_ID renames PF1;
   function D9  return Pin_ID renames PA8;
   function D10 return Pin_ID renames PA11;
   function D11 return Pin_ID renames PB5;
   function D12 return Pin_ID renames PB4;
   function D13 return Pin_ID renames PB3;
   function A0  return Pin_ID renames PA0;
   function A1  return Pin_ID renames PA1;
   function A2  return Pin_ID renames PA3;
   function A3  return Pin_ID renames PA4;
   function A4  return Pin_ID renames PA5;
   function A5  return Pin_ID renames PA6;
   function A6  return Pin_ID renames PA7;
   function A7  return Pin_ID renames PA2;
   
   type Input_Mode is (Direct, Pulled_Up);
   
   procedure Enable_Input (Pin : in Pin_ID; Mode : in Input_Mode);
   procedure Enable_Output (Pin : in Pin_ID);
   
   procedure Read (Pin : in Pin_ID; State : out Boolean);
   procedure Write (Pin : in Pin_ID; State : in Boolean);

   procedure Enable_Interrupts (Pin : in Pin_ID);
   procedure Disable_Interrupts (Pin : in Pin_ID);
   procedure Clear_Interrupt (Pin : in Pin_ID);

end Pins;
