package Utils is

   procedure Enable_Interrupts;
   
   procedure Disable_Interrupts;
   
   procedure Wait_For_Interrupt;

   procedure Enable_System_Time;

   type Time is new Natural;
   
   function Base_Tick return Time;
   
   function Clock return Time;
   
   procedure Reset_Clock (T : in Time := 0);
   
   procedure Delay_Until (T : in Time);
   
   type Task_Description is record
      Action : access procedure;
      Activation_Period : Time;
      
      Time_Since_Last_Due_Active : Time;
   end record;
   
   type Task_ID is new Positive;
   type Task_Descriptions is array (Task_ID range <>) of Task_Description;
   
   procedure Scheduler_Tick (Tasks : in out Task_Descriptions; Time_Passed : in Time);
   
   
   procedure SysTick_Handler;
   pragma Export (C, SysTick_Handler, "systick_handler");

end Utils;
